// EChENX@wb_t@C

#include <d3d8.h>
#include <d3dx8.h>
#include <dinput.h>
#include <math.h>

#define MAX_CHARA             1024 
#define MAX_INDEX_SIZE        (MAX_CHARA*6)
#define MAX_POLYGON           (MAX_CHARA*2)
#define MAX_VERTEX            (MAX_CHARA*4)
#define F(n)                  ((FLOAT)(n))
#define KEYDOWN(name, key)    (name[key] & 0x80) 
#define FRAME_PATTERN_WIDTH   8
#define FRAME_PATTERN_HEIGHT  8
#define SYSTEM_FONT_WIDTH     8
#define SYSTEM_FONT_HEIGHT    8
#define UI_FONT_WIDTH         16
#define UI_FONT_HEIGHT        16
#define BACK_COLOR_TOP        D3DCOLOR_RGBA(0,0,230,255)
#define BACK_COLOR_BOTTOM     D3DCOLOR_RGBA(0,0,70,255)
#define FRAME_COLOR           D3DCOLOR_RGBA(230,230,230,255)
#define FRAME_ZOOM_SIZE       2
#define MONOCOLOR             D3DCOLOR_RGBA(230,230,230,255)
#define RSHIFT			      64
#define CURSOL_WIDTH          16	
#define CURSOL_HEIGHT         16

// _\
struct TLVERTEX {
	FLOAT x,y,z,w;
	D3DCOLOR color;
	FLOAT u,v;
};
#define	FVF_TLVERTEX (D3DFVF_XYZRHW | D3DFVF_DIFFUSE | D3DFVF_TEX1)


// vf\́ivfƂ͂ł̓XvCg̈Ӗj
struct cts {
	int id;              // hc
    RECT dw;             // ]̋`
	RECT sc;             // ]̋`
	D3DCOLOR wcolor;      // \F
	bool focus;           // I\ڂǂ
	bool disp;            // \邩ǂ
	struct cts *cts_before;  //@̃|C^
};

//*******************
// XgfNX
//*******************
class tlistmodel {
private:
	 int  count;             // ̃Xgf̗vf
	 bool enabled;          // ̃Xgf\Ă邩ǂ
     LPDIRECT3DTEXTURE8 lptex; // ̃XgfŎgpiQƁjeNX`
	 int tex_width;         // ̃XgfQƂĂeNX`̕
	 int tex_height;        // ̃XgfQƂĂeNX`̍
	 int fnt_width;         // VXetHg̕
	 int fnt_height;        // VXetHg̍
	 bool modeltype;			//
	 int offset_x;          // ̃Xgfo^ĂEChENX̍XW
	 int offset_y;          // ̃Xgfo^ĂEChENX̍YW 
	 cts *cts_foword,*cts_buf; // Xg\Bcts_buf͏TOP̏
	 int idcount;           // IDBvfo^邽тID͂PB
	 int poly_num;          // ݂̃|SB|S͂Pvfɂ2Kv
	 int alpha_type;		 // ̃Xgf̃At@̎ 0:ʏ 1:Z 2:Z
	 bool glaymode;			  // ̃XgfOC[hijǂ
	 bool model_effect;		 // ̃XgfɂbĂtB^̗L
	 bool monomode;			 // ̃XgfPF\[hǂB̒ltruȅꍇAmonocolorŎw肵F
							  // ̃XgfŜ̗vfɂB

	 D3DCOLOR monocolor;	// PF\[h̃J[

	 bool convRect(RECT *rc,char *c);				// 1oCgɑΉtHgC[Ẅʒu߂
	 bool convRectSJIS(RECT *rc,char *c,int *daku); // 2oCgɑΉtHgC[Ẅʒu߂
	 
public:
	 tlistmodel(LPDIRECT3DTEXTURE8 texture,bool type);
	~tlistmodel();
	bool addInt(int dat,RECT *pdw,D3DCOLOR color,bool disp,bool focus);    // ̃Xgf֐vfƂēo^	
    bool addImage(RECT *pw,RECT *sc,D3DCOLOR color,bool disp,bool focus);  // ̃XgfփeNX`̎w肵̈vfƂēo^
	bool addChar(char *word,RECT *pdw,D3DCOLOR color,bool disp,bool focus); // ̃Xgf֕vfƂēo^
	bool addSJIS(char *word,RECT *pdw,D3DCOLOR color,bool disp,bool focus); // ̃XgfSJISvfƂēo^
	bool disp();						    // ̃Xgfׂ̂Ă̗vf\
	bool removeAllElements();			    // ̃Xgfׂ̂Ă̗vf폜
				
	bool setElementEnable(int id,bool boolean);   // ̃Xgf̎w肵IDvf\邩ǂ
	bool remove(int id);				    // ̃Xgf̎w肵IDvf폜
    bool setImage(int id,RECT *sc);			 // ̃Xgf̎w肵IDvf̃C[WVC[WɕύX
	bool setColor(int id,D3DCOLOR color);	// ̃Xgf̎w肵IDvf̐Fς
	bool setFocus(int id,bool focus);		// ̃Xgf̎w肵IDvf̃tH[JXύX
	bool setElementPosition(int id,int x,int y); // ̃Xgf̎w肵IDvf̕\ʒuݒ肷
    int getCursolMap(int *map,int get);		// J[\}bv𓾂
	int getElementPositionX(int id);  // w肵IDXW
	int getElementPositionY(int id);  // w肵IDXW
	

	// idƂ
	// addnŗvfo^Ƃ̗vfid^Bidaddns邽т1JEgB
	// ꂩo^vfɗ^id̒lmɂ́Ao^钼OgetId()̕Ԃl𒲂ׂƂ悢B

    //bool insartChar(int id,char *word); // ŵhc̎O֗vf}
    //bool insartInt(int id,int dat);  // ŵhc̎O֗vf}
	//bool insartImage(int id,RECT *sc); // ŵhc̎O֗vf}

	// CC
	inline bool setEnabled(bool boolean) { enabled=boolean; return true; }
	inline bool setEffect(bool effect) { model_effect=effect;  return true; }
	inline int getCount() { return count; }
	inline int getId() { return idcount; }
	inline bool setMono(bool boolean) { monomode=boolean; return true; }
	inline int getTexWidth() { return tex_width; }
    inline int getTexHeight() { return tex_height; }
	inline int getFontWidth() { return fnt_width; }
    inline int getFontHeight() { return fnt_height; }
	inline bool setFontSize(int w,int h) { fnt_width=w; fnt_height=h; return true; }
	inline int getOffsetX() { return  offset_x; }
	inline int getOffsetY() { return  offset_y; }

	

	// 2̃\bh̓EChENXĂԂ߂̂̂Ȃ̂ŎgpȂŉ
	inline bool setOffset(int ox,int oy) { 	offset_x=ox; offset_y=oy; return true; }
	inline bool glay(bool boolean) { glaymode=boolean; return true; }
};

//*****************
// t[NX
//*****************
class tframe {
private:
	RECT pattern_rect;        // t[̕\TCY@@@@
    int winframe_width;       // t[̘gp^[Pʂł̉TCY
	int winframe_height;      // t[̘gp^[Pʂł̏cTCY
    int winpix_width;		  // t[̘gsNZPʂł̉TCY
	int winpix_height;	      // t[̘gsNZPʂł̏cTCY
	bool enabled;             // t[\Ă邩
    bool focus;               // tH[JXĂ邩
    int  status;              // ̃t[݂̌̏ 0:S\ 1:gȂ 2:obNȂ 3:S
    D3DCOLOR color1,color2;   // obNJ[ color1FF color2: F
    D3DCOLOR fcolor;          // t[J[
	 int tex_width;           // ̃EBhE̘gp^[݂eNX`̕
	 int tex_height;          // ̃EBhE̘gp^[݂eNX`̍
	int frm_width,frm_height; // g̃p^[̃TCY
	int wintype;              // t[^Cv 0:obNobt@֒ڕ` 1:eNX`肻֕`ABB
    LPDIRECT3DTEXTURE8 lptex;				// ̃t[gp^[ƂĎgpeNX`
	cts *cts_buf,*cts_foword; // g̃Xg\
    int poly_num;             // |S
	int count;                // g̗vf
	int zoom;                // ̃t[̘gp^[̊g嗦BFRAME_ZOOM_SIZEftHgB
	int alpha_type;          // At@̎
	bool glaymode;           //@̃XgfOC[hijǂ
	bool model_effect;       // ̃t[ɂĂtB^̗L
    bool makeTexture();        // ʂ̃eNX`(wintype=1̎) 

public:
	tframe(LPDIRECT3DTEXTURE8 texture,int wintype);
	~tframe();
	bool addVline(int x); // t[̎wXʒuɏc
	bool addHline(int y); // t[̎wYʒuɉ
    bool initFrame(int width,int height);  // EChE̘gPʂł̃TCYݒ
    bool createFrame();  // t[\z
	inline bool setListModel(tlistmodel *lmodel) { 
		lmodel->setOffset(pattern_rect.left,pattern_rect.top); return true; }
    //bool actionCommand(int action);   // t[̊J̃ANV 
	inline bool glay(bool boolean) { glaymode=boolean; return true; }     // OCɂ邩ǂ 
	bool disp();                // t[\
	bool dispBackPanel();       // obNpl\
	bool setFramePosition(int x,int y);

	inline bool removeFrame() { return true; }
	inline bool setEffect(bool effect) { model_effect=effect;  return true; }
    inline bool setEnable(bool boolean) { enabled=boolean; return boolean; }
    inline bool isEnable() { return enabled; }
	inline bool setBackColor(D3DCOLOR col1,D3DCOLOR col2) {
		        color1=col1; color2=col2; return true;
				}
	inline D3DCOLOR getBackColor1() { return color1; }
    inline D3DCOLOR getBackColor2() { return color2; }
    inline bool setStatus(int state) { status=state; return true; }
    inline int getStatus() { return status; }
    inline bool setFocus(bool boolean) { focus=boolean; return boolean; }
    inline bool getFocus() { return focus; }
	inline int getFrameX() { return pattern_rect.left; }
	inline int getFrameY() { return pattern_rect.top; }
	inline int getFramePatternWidth() { return winframe_width; }
	inline int getFramePatternHeight() { return winframe_height; }
};


//**********************************************************************
// b\NXB1쐬Ήsłb[`ł܂B
// bZ[We̋L^͍s܂̂ŁAt[̓o^
// KvłB܂݂D3DXFontȂ̂Ŏpɂ͌܂B
// \ɊԂGtFNgtmessage
//**********************************************************************
class tmessage {
private:
	LPD3DXFONT lpD3DFONT;					// D3DXFontC^[tF[Xւ̃|C^
	bool render;							// trueȂ΃EChE`eNX`֏
	bool makefont;							//
	HFONT hFont,hFont_o;					// tHgIuWFNg
	HDC hDc;								// foCXR
	int width;								// tHg̕
	int height;								// tHg̍
//	char *fn;

public:
	tmessage();
	~tmessage();
	bool makeFont(char *fontname,int width,int height,int filter);
	bool drawMessage(char *message,int x,int y,D3DCOLOR color);
};

//*****************
// J[\NX
//*****************
class tcursol {
private:
		int width;			//	J[\p^[̕
		int height;			//  J[\p^[̍
		D3DCOLOR color;		//  J[\̐F
		int animespeed;		//  J[\̃Aj[Vx
		int curpix_x,curpix_y;			//  J[\̈ʒuiPIXEL)
		int exception;      //  O̓e(8AE6A2A4j
							//  Fvfc5łƉ肵ꍇAʏ탆[U[
							//      curmap_width1Acurmap_height5Ɛݒ肵Ăi͂j
							//      ̃J[\MAPōɈړꍇAȏi߂ȂߗOl4B
		bool strok;			//  ͉\Ԃǂ
		int mode;			// J[\[h̏(0:J[\@1Fs)
		int hepdepth;		// q[v̐[
		int map[512];			// J[\}bv
		bool skip;			// ѐ΂邩
		int counter;		// Aj[VJE^[
		int id;				// ݂ID
		int curmap_x,curmap_y;	// J[\MAP݂̌̈ʒu
		tlistmodel *tlm_cur; // tlistmodel̃|C^
		int curmap_width;	// J[\}bv̕
		int curmap_height;  // J[\}bv̍
		int elem;			// J[\}bv̑傫(elem<512)
		bool enabled;		// J[\\L
		int cursol_rot;		// J[\̉]
		int anm;			// J[\̃Aj[Vԍ
		int sellwidth;		// J[\}bṽZ̕
		int sellheight;		// J[\}bṽZ̍
		int sell_x;			// Z̍xW(pixel)
		int sell_y;			// Z̍yW(pixel)
		int cur_mode;		// J[\}bṽ[h(0:Z 1:C)
		int tex_width;		// J[\eNX`̕
		int tex_height;		// J[\eNX`̍
		LPDIRECT3DTEXTURE8 cursolimage; // J[\C[W

public:
	tcursol(LPDIRECT3DTEXTURE8 cimage,int mode);
	~tcursol(); // fXgN^ł͉Ȃ

	bool makeCursol(int width,int height,D3DCOLOR color);  // J[\쐬
	bool setCurmap1(tlistmodel *tlm,int w,int h,int swidth,int sheight);  //J[\̃}bvXgfNX
	bool disp();	// J[\\

	int  setCurmapPositionEx(int curmapx,int curmaxy);  // J[\\ʒuJ[\MAPWŎw肷iԂlIDj
	int  setCurmapPositionA(int id);  // J[\\ʒuXgfIDlŎw肷
//	int moveCursol(int vct);	// J[\ړƂ̏
//	int action(int act);		// ANV
	int key();					// L[͉\Ԃɂ
	int exceptionKey(int e);   // O
	//void clearHeap();				// q[vS폜
	
	inline int getCurmapId() { return id; }	// ݂̃J[\MAPʒuIDA͂̃NXۗLĂIDԂ
//	inline tlistmodel *getlistmodel() { return tlm_cur; }  // ̃J[\QƂĂ郊XgfԂ
	inline int getCurmap_width() { return curmap_width; } // J[\MAP̕Ԃ
	inline int getCurmap_height() { return curmap_height; }  // J[\MAP̕Ԃ
	inline bool getSkip() { return skip; }  // ѐ΂邩ǂ
	inline int getHeapDepth() { return hepdepth; } // Kw̐[
	inline bool setAnimeSpeed(int sanime) { animespeed=sanime; return true; } // J[\̃Aj[VXs[h
	inline bool getStrok() { return strok; }
	inline bool setStrok(bool boolean ) { strok=boolean; return true; }

	inline int getCurmapPositionX() { return curmap_x; }
	inline int getCurmapPositionY() { return curmap_y; }
//	 bool setPosition(int x,int y);     // J[\}bvǂݍ񂾂gpł܂

	inline int getPositionX() { return curpix_x; }
	inline int getPositionY() { return curpix_y; }
	inline void setCursolRot(int rot) { cursol_rot=rot; }
	inline bool setEnable(bool boolean) { enabled=boolean; return true; }
	inline bool getEnable() { return enabled; }
	inline bool setCursolMode(int cmode) { mode=cmode; return true; }

};